<?php

require_once 'base/GpeParamestrutmEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 *
 * @author  alessandrobartels - 18/11/11
 */
class GpeParamestrutmEntity extends GpeParamestrutmEntityBase
{

    private $_nrOrg;
    private $_mesCompetencia;

    private $_paramEstrutura;
    private $_nrEstruturaAnterior;


    /**
     * Construtor.
     *
     * @param integer    $id             Identificador.
     * @param integer    $nrOrg          Numero da Org. de Trabalho.
     * @param TkDateTime $mesCompetencia Mes de Competencia.
     */
    public function __construct($id = null, $nrOrg = null, TkDateTime $mesCompetencia = null){

        parent::__construct($id);

        $this->_nrOrg = $nrOrg;
//        $this->_mesCompetencia = $mesCompetencia;
        $this->_mesCompetencia = new TkDateTime(FPA::getDtCompetencia());
    }

    public function insereParametrosEstrutura($nrorg, $nrestruturam, $dtinivigencia) {
        $this->setNrorg($nrorg);
        $this->setNrestruturam($nrestruturam);
        $this->setDtinivigencia($dtinivigencia);
    }


    /**
     * Enter description here ...
     *
     * @return Ambigous <multitype:, NULL, Ambiguous, mixed>
     */
    public function getParamEstrutura() {
        return $this->_paramEstrutura;
    }


    /**
     * Enter description here ...
     *
     * @return integer
     */
    public function getNrParamFolha(){
        if (is_object($this->_paramEstrutura) === true) {
            return $this->_paramEstrutura->historico->getNrparamfolham();
        }
    }


    /**
     * Enter description here ...
     *
     * @return integer
     */
    public function getNrParamFerias(){
        if (is_object($this->_paramEstrutura) === true) {
            return $this->_paramEstrutura->historico->getNrparamferiasm();
        }
    }


    /**
     * Carrega instancia de GpeParamestrutmEntity agregado com GpeParamestruthEntity.
     *
     * @param integer $nrEstrutura Numero da Estrutura do vinculo.
     *
     * @throws Exception $e Propaga excecao.
     *
     * @return void
     *
     * @author alessandrobartels - 18/11/11
     * 		   thalesvalias - 01/12/11 - Parametro de estrutura eh armazenado na lista por demanda.
     */
    public function carregaParametrosEstrutra($nrEstrutura){
        try {
            if ($this->_nrEstruturaAnterior !== $nrEstrutura) {
                // Procura na lista e retorna a posicao.
                $posicao = $this->_procuraParametroEstrutura($nrEstrutura);

                if ($posicao === -1) {
                    // Procura na base caso nao exista na lista.
                    $this->_paramEstrutura = GpeParamestrutm::retornaParametrosEstrutra(
                        $this->_nrOrg, $this->_mesCompetencia, $nrEstrutura
                    );
                    if (is_object($this->_paramEstrutura) === true) {
                        $this->addItem($this->_paramEstrutura);
                        $this->_nrEstruturaAnterior = $nrEstrutura;
                    } else {
                        //@todo MsgCalculo
                        MsgCalculo::getInstance()->adicionaMensagem('Não encontrado registro de Parametro de Estrutura para a organização '.$this->_nrOrg,MsgCalculo::ERRO,true);
                        //tk_warning('Nao encontrado registro de Parametro de Estrutura para Org. '.$this->_nrOrg);
                    }
                } else {
                    $this->_paramEstrutura = $this->getItem($posicao);
                }
            }
        } catch (Exception $e){
            throw  $e;
        }

    }


    /**
     * Enter description here ...
     *
     * @param integer $nrEstrutura Numero da Estrutura.
     *
     * @return integer
     */
    private function _procuraParametroEstrutura($nrEstrutura) {

        $itens = $this->getItems();

        foreach ($itens as $key=>$item) {
            if (($item->getNrorg() === $this->_nrOrg) && ($item->getNrestruturam() === $nrEstrutura)) {
                return $key;
            }
        }

        return -1;
    }


}

